Sudoku
Time Limit: 3000/1000 MS (Java/Others) Memory Limit: 65535/65535 K (Java/Others)Total Submission(s): 1635 Accepted Submission(s): 574
Problem Description
Yi Sima was one of the best counselors of Cao Cao. He likes to play a funny game himself. It looks like the modern Sudoku, but smaller.
Actually, Yi Sima was playing it different. First of all, he tried to generate a 4×4
board with every row contains 1 to 4, every column contains 1 to 4. Also he made sure that if we cut the board into four 2×2
pieces, every piece contains 1 to 4.
Then, he removed several numbers from the board and gave it to another guy to recover it. As other counselors are not as smart as Yi Sima, Yi Sima always made sure that the board only has one way to recover.
Actually, you are seeing this because you've passed through to the Three-Kingdom Age. You can recover the board to make Yi Sima happy and be promoted. Go and do it!!!
Actually, Yi Sima was playing it different. First of all, he tried to generate a 4×4
Then, he removed several numbers from the board and gave it to another guy to recover it. As other counselors are not as smart as Yi Sima, Yi Sima always made sure that the board only has one way to recover.
Actually, you are seeing this because you've passed through to the Three-Kingdom Age. You can recover the board to make Yi Sima happy and be promoted. Go and do it!!!
Input
The first line of the input gives the number of test cases, T(1≤T≤100)
. T
test cases follow. Each test case starts with an empty line followed by 4 lines. Each line consist of 4 characters. Each character represents the number in the corresponding cell (one of '1', '2', '3', '4'). '*' represents that number was removed by Yi Sima.
It's guaranteed that there will be exactly one way to recover the board.
It's guaranteed that there will be exactly one way to recover the board.
Output
For each test case, output one line containing Case #x:, where x
is the test case number (starting from 1). Then output 4 lines with 4 characters each. indicate the recovered board.
Sample Input
3 **** 2341 4123 3214 *243 *312 *421 *134 *41* **3* 2*41 4*2*
Sample Output
Case #1: 1432 2341 4123 3214 Case #2: 1243 4312 3421 2134 Case #3: 3412 1234 2341 4123
Source
The 2015 China Collegiate Programming Contest
思路:
给定一个4*4矩阵,让你填数,确保每行、每列、每1/4区域(就是左上角左下角右上角右下角)都没有重复的元素。因为每个区域只有4个位置,只有4个数,所以每个位置方法肯定是只有一个。直接用dfs搜索,对于每个*点试探放进去1~4这四个数,这里用到的一个技巧是dfs函数传入的是一个数,而不是坐标,因为由这个数是多少就能确定点的坐标,这样更好想也好做一点。。。
代码:
- #include<iostream>
- #include<cstdio>
- #include<cstring>
- #include<cmath>
- #include<algorithm>
- using namespace std;
- char maps[110][110];
- int judge(int row,int col)
- {
- int i,j;
- for(i=0;i<4;i++) //同行
- {
- if( i!=col && maps[row][i]==maps[row][col])
- return 0;
- }
- for(i=0;i<4;i++) ///同列
- {
- if( i!=row && maps[i][col]==maps[row][col])
- return 0;
- }
- //1/4区域 分成4块分别求
- if(row<2)
- {
- if(col<2)
- {
- for(i=0;i<2;i++)
- {
- for(j=0;j<2;j++)
- if(row!=i && col!=j && maps[i][j]==maps[row][col])
- return 0;
- }
- }
- else
- {
- for(i=0;i<2;i++)
- {
- for(j=2;j<4;j++)
- if(row!=i && col!=j && maps[i][j]==maps[row][col])
- return 0;
- }
- }
- }
- else
- {
- if(col<2)
- {
- for(i=2;i<4;i++)
- {
- for(j=0;j<2;j++)
- if(row!=i && col!=j && maps[i][j]==maps[row][col])
- return 0;
- }
- }
- else
- {
- for(i=2;i<4;i++)
- {
- for(j=2;j<4;j++)
- if(row!=i && col!=j && maps[i][j]==maps[row][col])
- return 0;
- }
- }
- }
- return 1;
- }
- void dfs(int cur)
- {
- int i,j;
- if(cur==16)
- {
- for(i=0;i<4;i++)
- {
- for(j=0;j<4;j++)
- printf("%c",maps[i][j]);
- printf("\n");
- }
- return ;
- }
- int row=cur/4;
- int col=cur%4;
- if(maps[row][col]=='*')
- {
- for(i=1;i<=4;i++)
- {
- maps[row][col]=i+'0';
- if(judge(row,col)==1)
- {
- dfs(cur+1);
- }
- maps[row][col]='*';
- }
- }
- else
- dfs(cur+1);
- }
- int main()
- {
- int T,cas=1,i;
- scanf("%d",&T);
- while(T--)
- {
- for(i=0;i<4;i++)
- scanf("%s",maps[i]);
- printf("Case #%d:\n",cas++);
- dfs(0);
- }
- return 0;
- }